routes/web.php
<?php
date_default_timezone_set('Asia/Jakarta');
/* Route For Main View */
Route::get('/', function () {
    return redirect('/login');
});

/* Route For Auth */
Auth::routes();

/* Route For Main Menu */
Route::group(
    [
        'prefix' => 'admin',
        'middleware' => ['auth', 'role:admin|member'],
    ],
    function () {
        //Route Home
        Route::get('/home', 'admin\HomeController@index');
        
        //Route Change Password
        Route::get('change_password', [
            'as' => 'change_password',
            'uses' => 'Admin\UsersController@changePassword',
        ]);
        Route::post('store_password', [
            'as' => 'store_password',
            'uses' => 'Admin\UsersController@storeNewPassword',
        ]);

    }
);

Route::group(
    [
        'prefix' => 'admin',
        'middleware' => ['auth', 'role:admin'],
    ],
    function () {
        //Route Resource        
        Route::resource('master/users', 'Admin\UsersController');
        Route::resource('master/lapangan', 'Admin\LapanganController');
        Route::resource('master/harga', 'Admin\HargaController');

        //Route Booking
        Route::get('transaksi/booking/create/{date}', [
            'as' => 'booking.create',
            'uses' => 'Admin\BookingController@create',
        ]);

        Route::post('transaksi/booking/form_booking', [
            'as' => 'booking.form_booking',
            'uses' => 'Admin\BookingController@formBooking',
        ]);

        Route::post('transaksi/booking_list/form_booking_edit', [
            'as' => 'booking.form_booking_edit',
            'uses' => 'Admin\BookingController@formBookingEdit',
        ]);

        Route::post('transaksi/booking/store', [
            'as' => 'booking.store',
            'uses' => 'Admin\BookingController@store',
        ]);

        Route::put('transaksi/booking_list/update/{booking_id}', [
            'as' => 'booking.update',
            'uses' => 'Admin\BookingController@update',
        ]);

        Route::get('transaksi/booking_list', [
            'as' => 'booking.index',
            'uses' => 'Admin\BookingController@index',
        ]);

        Route::get('transaksi/booking_list/{booking_id}/edit', [
            'as' => 'booking.edit',
            'uses' => 'Admin\BookingController@edit',
        ]);

        Route::delete('transaksi/booking/destroy/{booking_id}', [
            'as' => 'booking.destroy',
            'uses' => 'Admin\BookingController@destroy',
        ]);

        //Route Tagihan
        Route::get('transaksi/tagihan', [
            'as' => 'tagihan.index',
            'uses' => 'Admin\PembayaranController@index',
        ]);

        Route::get('transaksi/tagihan/{user_id}/detail', [
            'as' => 'tagihan.detail',
            'uses' => 'Admin\PembayaranController@detailTagihan',
        ]);

        Route::post('transaksi/store', [
            'as' => 'tagihan.store',
            'uses' => 'Admin\PembayaranController@store',
        ]);

        //Route Pembayaran
        Route::get('pembayaran/laporan/{tahun}', [
            'as' => 'pembayaran.laporan',
            'uses' => 'Admin\PembayaranController@laporanPembayaran',
        ]);

        Route::get('pembayaran/laporan/{user_id}/{tahun}/detail', [
            'as' => 'pembayaran.detail',
            'uses' => 'Admin\PembayaranController@detailPembayaran',
        ]);

        Route::post('pembayaran/koreksi', [
            'as' => 'pembayaran.koreksi',
            'uses' => 'Admin\PembayaranController@koreksi',
        ]);

        Route::get('pembayaran/chart/{tahun}', [
            'as' => 'pembayaran.chart',
            'uses' => 'Admin\PembayaranController@chart',
        ]);

        //Last Record Harga
        Route::get('last_record_harga/{lapangan_id}/{hari}', 'Admin\HargaController@lastRecord');

    }
);


Route::get('auth/verify/{token}', 'Auth\RegisterController@verify');
Route::get('auth/send-verification', 'Auth\RegisterController@sendVerification');

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Laratrust\Traits\LaratrustUserTrait;
use Illuminate\Support\Facades\Mail;

class User extends Authenticatable
{
    use LaratrustUserTrait;
    use Notifiable;

    protected $fillable = [
        'name', 'email', 'password',
    ];

    protected $hidden = [
        'password', 'remember_token',
    ];

    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function generateVerificationToken()
    {
        $token = $this->verification_token;
        if(!$token){
            $token = str_random(40);
            $this->verification_token = $token;
            $this->save();
        }
        return $token;
    }

    public function sendVerification()
    {
        $token = $this->generateVerificationToken();
        $user = $this;
        Mail::send('auth.emails.verification', compact('user', 'token'), function ($m) use ($user){
            $m->to($user->email, $user->name)->subject('Futsal verification email');
        });
    }

    public function verify()
    {
        $this->email_verified_at = date('Y-m-d H:i:s');
        $this->is_verified = 1;
        $this->verification_token  = null;
        $this->save();
    }

    public function booking()
    {
        return $this->hasMany('App\Booking');
    }
}

app/Http/Controllers/Admin/UsersController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Role;
use App\Rules\MatchOldPassword;
use App\User;
use Auth;
use Datatables;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;
use Validator;

class UsersController extends Controller
{
    public function index(Request $request)
    {
        if ($request->ajax()) {
            $users = User::select(['id', 'name', 'email'])->get();
            return Datatables::of($users)
                ->addColumn('role', function ($user) {
                    return ucfirst($user->roles[0]->name);
                })
                ->addColumn('action', function ($user) {
                    return view('admin.datatables._action', [
                        'id' => $user->id,
                        'destroy_url' => route('users.destroy', $user->id),
                        'edit_url' => route('users.edit', $user->id),
                        'confirm_message' => 'Apakah anda yakin ingin menghapus pengguna ' . $user->name . ' ?',
                    ]);
                })
                ->rawColumns(['role', 'action'])
                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('name'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['name'], $request->get('name')) ? true : false;
                        });
                    }
                    if (!empty($request->get('email'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['email'], $request->get('email')) ? true : false;
                        });
                    }
                    if (!empty($request->get('role'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['role'], $request->get('role')) ? true : false;
                        });
                    }
                })
                ->make(true);
        }

        $data['title'] = 'Daftar Pengguna';
        return view('admin.user.index', $data);
    }

    public function create()
    {
        $data['title'] = 'Tambah Pengguna';
        return view('admin.user.create', $data);
    }

    public function store(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'name' => 'required|max:255',
            'email' => 'required|email|max:255|unique:users',
            'password' => 'required|confirmed|min:8',
        ]);

        if ($validator->passes()) {
            $data = $request->except('role_id');
            $data['password'] = bcrypt($data['password']);

            $user = User::create($data);
            $role = Role::where('id', $request->role_id)->first();
            $user->attachRole($role);
            $user->sendVerification();
            return response()->json(['success' => 'Berhasil menambahkan Pengguna']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }

    }

    public function show($id)
    {
        //
    }

    public function edit($id)
    {
        $title = 'Edit Pengguna';
        $user = User::find($id);
        return view('admin.user.edit')->with(compact('user', 'title'));
    }

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'required|max:255',
            'email' => 'required|unique:users,email,' . $id,
            'password' => 'nullable',
        ]);

        if ($validator->passes()) {
            $user = User::find($id);
            $data = $request->except('role_id');
            $user->update($data);
            $user->roles()->sync([$request->role_id]);
            return response()->json(['success' => 'Berhasil mengubah data Pengguna']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }

    }

    public function destroy($id)
    {
        if (Auth::user()->id != $id) {
            $user = User::where('id', $id)->delete();
            return response()->json(['id' => $id]);
        } else {
            return response()->json(['error' => 'Gagal menghapus Pengguna']);
        }
    }

    public function changePassword()
    {
        $data['title'] = 'Ganti Password';
        return view('admin.user.change_password', $data);
    }

    public function storeNewPassword(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'current_password' => ['required', new MatchOldPassword],
            'new_password' => 'required',
            'new_confirm_password' => 'required|same:new_password|min:8',
        ]);

        if ($validator->passes()) {
            User::find(Auth::user()->id)->update(['password' => Hash::make($request->new_password)]);
            return response()->json(['success' => 'Berhasil mengubah data Pengguna']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }
}

resources/views/admin/user/_form.blade.php
<div class="form-group group-name">
    {!! Form::label('name', 'Nama', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-user"></span>
            </span>
            {!! Form::text('name', null, ['class' => 'form-control']) !!}
        </div>
    </div>
</div>

<div class="form-group group-email">
    {!! Form::label('email', 'Alamat E-mail', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-envelope"></span>
            </span>
            {!! Form::email('email', null, ['class' => 'form-control']) !!}
        </div>
    </div>
</div>

@if (last(request()->segments()) != 'edit')
<div class="form-group group-password">
    {!! Form::label('password', 'Password', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-lock"></span>
            </span>
            {!! Form::password('password', ['class' => 'form-control']) !!}
        </div>
    </div>
</div>

<div class="form-group">
    {!! Form::label('password_confirmation', 'Konfirmasi Password', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-lock"></span>
            </span>
            {!! Form::password('password_confirmation', ['class' => 'form-control']) !!}
        </div>
    </div>
</div>
@endif

@if(!empty($user))
<div class="form-group">
    {!! Form::label('role_id', 'Pilih Role', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-key"></span>
            </span>
            {!! Form::select('role_id', App\Role::pluck('display_name', 'id')->all(), $user->roles, ['class' =>'form-control']) !!}
        </div>
    </div>
</div>
@else
<div class="form-group">
    {!! Form::label('role_id', 'Pilih Role', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-key"></span>
            </span>
            {!! Form::select('role_id', App\Role::pluck('display_name', 'id')->all(), null, ['class' =>'form-control']) !!}
        </div>
    </div>
</div>
@endif

resources/views/admin/user/change_password.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li class="active">Ganti Password</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Password</h3>
                </div>
                {!! Form::open(['url' => route('store_password'),
                'class' => 'form-horizontal form-save',
                'method' =>'post',
                'data-btn' => 'btn-save',
                'data-rule' => 'store']) !!}
                <div class="panel-body">
                    <div class="row">
                        <div class="col-md-6">

                            <div class="form-group group-current_password">
                                {!! Form::label('current_password', 'Password Lama', ['class' => 'col-md-3 control-label'])
                                !!}
                                <div class="col-md-9 col-xs-12">
                                    <div class="input-group">
                                        <span class="input-group-addon">
                                            <span class="fa fa-lock"></span>
                                        </span>
                                        {!! Form::password('current_password', ['class' => 'form-control']) !!}
                                    </div>
                                    {!! $errors->first('current_password', '<p class="help-block">:message</p>') !!}
                                </div>
                            </div>

                            <div class="form-group group-new_password">
                                {!! Form::label('new_password', 'Password Baru', ['class' => 'col-md-3 control-label'])
                                !!}
                                <div class="col-md-9 col-xs-12">
                                    <div class="input-group">
                                        <span class="input-group-addon">
                                            <span class="fa fa-lock"></span>
                                        </span>
                                        {!! Form::password('new_password', ['class' => 'form-control']) !!}
                                    </div>
                                    {!! $errors->first('new_password', '<p class="help-block">:message</p>') !!}
                                </div>
                            </div>

                            <div class="form-group group-new_confirm_password">
                                    {!! Form::label('new_confirm_password', 'Konfirmasi Password Baru', ['class' => 'col-md-3 control-label'])
                                    !!}
                                    <div class="col-md-9 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon">
                                                <span class="fa fa-lock"></span>
                                            </span>
                                            {!! Form::password('new_confirm_password', ['class' => 'form-control']) !!}
                                        </div>
                                        {!! $errors->first('new_confirm_password', '<p class="help-block">:message</p>') !!}
                                    </div>
                                </div>

                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
<script type="text/javascript">

</script>
@endsection

resources/views/admin/user/create.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Pengguna</li>
    <li class="active">Tambah Data</li>
</ul>


<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Pengguna</h3>
                </div>
                {!! Form::open(['url' => route('users.store'),
                    'class' => 'form-horizontal form-save',
                    'method' =>'post',
                    'data-btn' => 'btn-save',
                    'data-rule' => 'store']) !!}
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('users.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.user._form')
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/user/edit.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Pengguna</li>
    <li class="active">Edit</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Pengguna</h3>
                </div>
                {!! Form::model($user, ['url' => route('users.update', $user->id),
                    'class' => 'form-horizontal form-save',
                    'method' =>'put',
                    'data-btn' => 'btn-save',
                    'data-redirect' => route('users.index')]) !!}
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('users.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.user._form')
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/user/index.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li class="active">Pengguna</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Daftar Pengguna</h3>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <a class="btn btn-default waves-effect" href="{{ route('users.create') }}">Tambah Pengguna</a>
                        <hr>
                        <div class="col-md-12">
                            <table id="users" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th width="10%">ID</th>
                                        <th>Nama</th>
                                        <th>Email</th>
                                        <th>Role</th>
                                        <th width="10%">Action</th>
                                    </tr>
                                </thead>
                                <tfoot>
                                    <tr>
                                        <td></td>
                                        <td>
                                            {!! Form::text('name', null, ['class' => 'form-control', 'placeholder' => 'Nama', 'id' => 'name']) !!}
                                        </td>
                                        <td>
                                            {!! Form::email('email', null, ['class' => 'form-control', 'placeholder' => 'Email', 'id' => 'email']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('role', null, ['class' => 'form-control', 'placeholder' => 'Role', 'id' => 'role']) !!}
                                        </td>
                                        <td></td>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
<script type="text/javascript">
    $(function () {
        var table = $('#users').DataTable({
            processing: false,
            serverSide: true,
            order: [ [0, 'desc'] ],
            ajax: {
                url: "{{ route('users.index') }}",
                data: function (d) {
                    d.name = $('#name').val(),
                    d.email = $('#email').val(),
                    d.role = $('#role').val()
                }
            },
            columns: [{
                    data: 'id',
                    name: 'id'
                },
                {
                    data: 'name',
                    name: 'name'
                },
                {
                    data: 'email',
                    name: 'email'
                },
                {
                    data: 'role',
                    name: 'role'
                },
                {
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });

        $('#name').on('change', function () {
            table.draw();
        });

        $('#email').on('change', function () {
            table.draw();
        });

        $('#role').on('change', function () {
            table.draw();
        });
    });
</script>
@endsection

@section('style')
<style>
    #users_filter {
        display: none;
    }
    #users_length {
        width: 100%;
    }
</style>
@endsection